#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include <syslog.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdlib.h>

#include <termios.h>

#define BUFSIZE 127
#define port 110
#define mail "mail"

static char CRLF[3]={13,10,0};

static char buf[BUFSIZE];
static char bufio[BUFSIZE];
static char pass_buf[BUFSIZE];

struct termios term;
tcflag_t oldflags;
int  cterm; // 

void mode();  /*    */
void reset(); /*    */

static int sd;


void recvstring()
{
 int i;
  char* s = bufio-1;
   do{
    s++;
    i=recv(sd,s,1,0);       //   
    if( i==0 ) continue;
    }while(*s!='\n');
   s++;
   *s='\0';
}

void quit()
{
  send(sd,"QUIT\n",5,0);
  recvstring();
  printf(bufio);
}

void sendstring(char* s,char* s2,short g)
{
 int i;
   strcpy(bufio,s);
   strcat(bufio," ");
   strcat(bufio,s2);
   strcat(bufio,"\n");
   send(sd,bufio,strlen(bufio),0);
   recvstring();
   if( !(g && bufio[0]=='-') ) printf("%s",bufio);
   if( bufio[0]=='-' ) quit(), exit(1);
}


main(int ac,char** av)
{
int i, c, k;
struct sockaddr_in  s_a;
struct hostent* hp;

 if(ac<3) fprintf(stderr,"%s:    : host, user\n",av[0]), exit(1);

 bzero(&s_a,sizeof s_a);

 hp = gethostbyname(av[1]);
 if( !hp )
  s_a.sin_addr.s_addr = inet_addr(av[1]); /*       4-*/
 else
  bcopy(hp->h_addr,&s_a.sin_addr,hp->h_length);

 sd=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP); /*   */
 if( sd<0 ){  perror(av[0]); exit(1);}
  /*  */

    s_a.sin_family=AF_INET;
    s_a.sin_port=htons(port); /*  port */

  /*  */
  if( connect(sd,(struct sockaddr*)&s_a,sizeof(s_a))<0 ){ perror(av[0]); exit(1);}
   i=recv(sd,buf,BUFSIZE,0); //   
   buf[i]='\0';                //   0
   printf("%s",buf);

 sendstring("USER",av[2],0);

 printf("Enter password:");
   /* .   */
 mode();
  fgets(pass_buf,BUFSIZE,stdin);
 reset();
 printf("\n");

 pass_buf[strlen(pass_buf)-1]='\0';
 sendstring("PASS",pass_buf,0);
 sendstring("STAT","",0);

  chdir(getenv("HOME"));
   mkdir(mail,0700);
   

  for(k=1; ; k++){
  FILE* f;
  char x[6];

   sprintf(x,"%i",k);
   
   sendstring("RETR",x,1);
   
   sprintf(buf,mail "/%i",k);
   unlink(buf); //  
   f = fopen(buf,"w");
   if(!f)
   {
    fprintf(stderr,"pop3u: not open file %i\n",k);
    break;
   }

   do{
	recvstring();
	if(bufio[0]=='.' && strcmp(bufio+1,CRLF)==0) break;
	fprintf(f,"%s",bufio);
   }while(1);
   fclose(f);
   
  }

  quit();
  close(sd);
}

void mode()
{
    cterm = open("/dev/tty",O_RDWR);
    tcflush(cterm,TCIOFLUSH); //  
    tcgetattr(cterm,&term);  //  
    oldflags = term.c_lflag;	  //  
    //    ,
    //   SIGTTOU ( TOSTOP)
    //  SIGINT, SIGQUIT, SIGTSTP ( ISIG)
    term.c_lflag=term.c_lflag&(~ICANON)&(~ECHO)|TOSTOP|ISIG;
    tcsetattr(cterm,TCSANOW,&term); //  
}

void reset(){
    term.c_lflag=oldflags;
    tcsetattr(cterm,TCSANOW,&term); // 
}
